## @file ScoreDisplay.py
#  @author Vaibhav Chadha
#  @brief implements the interface after the snake dies
#  @date 11/22/2018

import pygame, sys
import highscore, Interface, Gameplay

def storeScore(score):
    prevScore = int(highscore.HighScore.findHighScore())
    #print(prevScore)
    if(score > prevScore):
        infile = open("highscore.txt", "w")
        infile.write(str(score))
    else: return

def display(score,speed, colour,food_colour, backgroundColour):
    pygame.init()
    storeScore(score)
    lightBlue = [89,131,145]
    darkgray = [100,100,100]
    white = [255,255,255]
    image1 = pygame.image.load("Exit_image.png")

    
    run = True
    while run:

        
        mousepos = pygame.mouse.get_pos() #checking mouse position
        mouseclick = pygame.mouse.get_pressed()#checking mouse pressed
        lastPage = pygame.display.set_mode((500, 500))
        lastPage.blit(image1,(0,0))
##        lastPage.fill()

        highscore.HighScore.text('Your Highscore is ' + str(score),"maiandragd", 35,[0, 0, 0],(70,50),lastPage)

        if (150 <= mousepos[0] <= 150+200 and 150 <= mousepos[1] <= 150+60 ):
            highscore.HighScore.button(lastPage,darkgray, [150,150,200,60], 0)
            if mouseclick[0] == 1:
                Gameplay.game(speed, colour,food_colour, backgroundColour)
        else:
            highscore.HighScore.button(lastPage,lightBlue, [150,150,200,60], 0)
        highscore.HighScore.text('Play Again',"maiandragd", 25, white,(193,165),lastPage)

        if (150 <= mousepos[0] <= 150+200 and 260 <= mousepos[1] <= 260+60 ):
            highscore.HighScore.button(lastPage,darkgray, [150,260,200,60], 0)
            if mouseclick[0] == 1:
                Interface.main()
        else:
            highscore.HighScore.button(lastPage,lightBlue, [150,260,200,60], 0)
        highscore.HighScore.text('Main Menu',"maiandragd", 25,white,(189,275),lastPage)
        
        if (150 <= mousepos[0] <= 150+200 and 370 <= mousepos[1] <= 370+60 ):
            highscore.HighScore.button(lastPage,darkgray, [150,370,200,60], 0)
            if mouseclick[0] == 1:
                pygame.quit()
                sys.exit()
        else:
            highscore.HighScore.button(lastPage,lightBlue, [150,370,200,60], 0)
        highscore.HighScore.text('Quit',"maiandragd", 25,white,(225,385),lastPage)
            
        pygame.display.update()

#display(99)
